program Kopernik;
{$X+}
uses
  graph, crt;
const
  G:real=-1;dt:real=0.0001;
  max_cial=6;ile_cial:integer=5;
  Xmax:real=553;Xmin:real=-553;
  Ymax:real=250;Ymin:real=-600;
type
  obiekt=record
           m:real;
           x,y:real;
           Vx,Vy:real;
           c:integer;
           fxmdt,fymdt:real;
           exp,eyp:integer;
         end;
const
  poczat:array[1..max_cial] of obiekt=
 ((m:100000;x:0;y:0;Vx:0;Vy:0;c:Magenta),
  (m:1000;x:260;y:-520;Vx:8;Vy:6;c:LightCyan),
  (m:10;x:265;y:-523;Vx:1;Vy:-1;c:Yellow),
  (m:1;x:300;y:620;Vx:-23;Vy:-20;c:White),
  (m:0.25;x:265;y:-520;Vx:-1;Vy:40;c:Red),
  (m:0));

var
  P:LONGINT;
  pom,skalax,skalay:real;
  yres,xres:integer;
  koniec,rysuj:boolean;
  grdrv,grmode:integer;
procedure wyswietl_tor(var cialo:obiekt);
var
  px,py:integer;
begin
  with cialo do
  begin
    px:=round((x-Xmin)*skalax);
    py:=round((y-Ymin)*skalay);
    if ((px>0) and (px<xres) and (py>0) and (py<yres))
or
       ((exp>0) and (exp<xres) and (eyp>0) and (eyp<yres)) then
    begin
      setcolor(c);
      line(exp,yres-eyp,px,yres-py);
    end;
    exp:=px; eyp:=py;
  end;
end;

procedure rysuj_tory;
var
  nr_ciala, drugie_cialo:integer;
  dx,dy,sumsq:real;
  fxwew,fywew:real;
  init:boolean;
  fmdt:real;
  cialo:array[1..max_cial] of obiekt;
  gmdt:array[1..max_cial] of array[1..max_cial] of real;
begin
  init:=true;
  for nr_ciala:=1 to ile_cial do
  begin
    cialo[nr_ciala]:=poczat[nr_ciala];
    with cialo[nr_ciala] do
      begin
        if m<=0 then
        begin
               TextMode(C80);
               writeln('Nie zainicjalizowano ciala',nr_ciala);
               init:=false;
        end
        else
        begin
          exp:=round((x-Xmin)*skalax); eyp:=round((y-Ymin)*skalay);
          fxmdt:=0; fymdt:=0;
          for drugie_cialo:=1 to ile_cial do
          gmdt[nr_ciala][drugie_cialo]:=G*dt*poczat[drugie_cialo].m*poczat[nr_ciala].m;
        end;
      end;
  end;
  if init then
    while not keypressed do
      for nr_ciala:=1 to ile_cial do
      with cialo[nr_ciala] do
      begin
        for drugie_cialo:=nr_ciala+1 to ile_cial do
        begin
          dx:=x-cialo[drugie_cialo].x;
          dy:=y-cialo[drugie_cialo].y;
          sumsq:=dx*dx+dy*dy;
          if sumsq>0 then
          begin
            fmdt:=gmdt[nr_ciala][drugie_cialo]/(sumsq*sqrt(sumsq));
            fxwew:=fmdt*dx; fywew:=fmdt*dy;
            fxmdt:=fxmdt+fxwew; fymdt:=fymdt+fywew;
            cialo[drugie_cialo].fxmdt:=cialo[drugie_cialo].fxmdt-fxwew;
            cialo[drugie_cialo].fymdt:=cialo[drugie_cialo].fymdt-fywew;
          end;
        end;
        Vx:=Vx+fxmdt/m; Vy:=Vy+fymdt/m;
        x:=x+Vx*dt; y:=y+Vy*dt;
        fxmdt:=0; fymdt:=0;
        wyswietl_tor(cialo[nr_ciala]);
        FOR P:=1 TO 1000000 DO BEGIN END;
        end;

  readkey;
end;

function wcz_licz(tekst:string; var wart:real):
boolean;
var
  linia:string;
  blad:integer;
  koncz:boolean;
  wczyt:real;
begin
  write(tekst,'(=',wart:2:2,'):');
  readln(linia);
  if linia='' then
    wcz_licz:=false
  else
  begin
    val(linia,wczyt,blad);
    wart:=wczyt;
    wcz_licz:=true;
  end;
end;

procedure wczytaj_cialo(nr:integer;var cialo:obiekt);
var
  wczyt:real;
  dalej:boolean;
begin
  writeln('Podaj nastepujace parametry ciala',nr,'(ENTER - bez zmian)');
  with cialo do
  begin
    wcz_licz('m',m);
    wcz_licz('x',x);wcz_licz('y',y);
    wcz_licz('Vx',Vx);wcz_licz('Vy',Vy);
    wczyt:=c;wcz_licz('kolor toru',wczyt);
    c:=round(wczyt)
  end;
end;

procedure wczytaj_konfig;
var
  pom:real;
  dalej:boolean;
begin
  writeln('Podaj nastepujace parametry srodowiska (sam ENTER pozostawia je bez zmian):');
  wcz_licz('G',G);wcz_licz('dt',dt);
  pom:=ile_cial; wcz_licz('ile_cial',pom);
  if (pom>0) and (round(pom) <= max_cial) then ile_cial:=round(pom)
  else
  begin
    writeln('ilosc cial musi byc wieksza od zera i mniejsza niz ',max_cial);
    writeln('zostawiam stara wartosc');
  end;
  wcz_licz('Xmax',Xmax); wcz_licz('Xmin',Xmin);
  wcz_licz('Ymax',Ymax); wcz_licz('Ymin',Ymin);
end;

procedure rysuj_tory_wolne;
var
  nr_ciala, drugie_cialo :integer;
  dx,dy,sumsq:real;
  fx,fy:real;
  init:boolean;
  fg:real;
  cialo:array[1..max_cial] of obiekt;
begin
  init:=true;
  for nr_ciala:=1 to ile_cial do
  begin
    cialo[nr_ciala]:=poczat[nr_ciala];
    with cialo[nr_ciala] do
    begin
      if m<=0 then
      begin
        TextMode(C80);
        writeln('Nie zainicjalizowano ciala',nr_ciala);
        init:=false;
      end
      else
        exp:=round((x-Xmin)*skalax); eyp:=round((y-Ymin)*skalay);
    end;
  end;
  if init then
  while not keypressed do
    for nr_ciala:=1 to ile_cial do
    with cialo[nr_ciala] do
    begin
      fx:=0;fy:=0;
      for drugie_cialo:=1 to ile_cial do
      begin
        dx:=x-cialo[drugie_cialo].x;
        dy:=y-cialo[drugie_cialo].y;
        sumsq:=dx*dx+dy*dy;
        if sumsq>0 then
        begin
          fg:=G*m*cialo[drugie_cialo].m/(sumsq);
          fx:=fx+fg*dx/sqrt(sumsq);
          fy:=fy+fg*dy/sqrt(sumsq);
        end
      end;
      Vx:=Vx+dt*fx/m; Vy:=Vy+dt*fy/m;
      x:=x+Vx*dt; y:=y+Vy*dt;
      wyswietl_tor(cialo[nr_ciala]);
      end;
  readkey;
end;


begin
  koniec:=false; grdrv:=detect;
  repeat
    TextMode(CO80); rysuj:=false;
    repeat
      writeln('Podaj numer ciala (1..',ile_cial,'). by zmienic jego parametry');
      writeln('podaj 0, by zmienic konfiguracje');
      writeln('podaj wartosc ujemna by skonczyc prace');
      writeln('sam ENTER powoduje rysowanie torow.');
      if wcz_licz('',pom) then
      begin
        if pom<0 then
        begin
          koniec:=true; rysuj:=true;
        end
        else
        if pom=0 then wczytaj_konfig
        else
        if pom<=ile_cial then
          wczytaj_cialo(round(pom),poczat[round(pom)])
        else
          writeln('Cialo o tym numerze nie istnieje. Mozesz zwiekszyc liczbe cial w konfiguracji');
      end
      else
        rysuj:=true;
    until rysuj;
    if not koniec then
    begin
      InitGraph(grdrv,grmode,'D:\FPC\3.0.0\bgi');
      xres:=GetmaxX; yres:=GetmaxY;
      skalax:=xres/(Xmax-Xmin); skalay:=yres/(Ymax-Ymin);
      rysuj_tory_wolne;
    end;
  until koniec;
end.

